const { keyboard, Key, mouse, left, right, up, down, screen, Button, OptionalSearchParameters } = require("@nut-tree/nut-js");
const puppeteer = require('puppeteer');

// clickControl is defined inside the module so we can call it wherever we want
async function clickControl() {
  screen.config.resourceDirectory = "resources";
  let control = await screen.find("addtocart.png");
  await moveMouseToControl(control);
  //click(Button.MIDDLE)
}

function click(button) {
  switch (button) {
    case Button.LEFT:
      mouse.leftClick();
    case Button.RIGHT:
      mouse.rightClick();
    case Button.MIDDLE:
      mouse.pressButton(button);
      mouse.releaseButton(button);
  }
}

async function getScreenSize() {
  let screenHeight;
  let screenWidth;
  let getHeight = screen.height().then(y => {
    screenHeight = y;
  });
  let getWidth = screen.width().then(x => {
    screenWidth = x;
  });
  await getHeight;
  await getWidth;
  return {
    y: screenHeight,
    x: screenWidth
  };
}

async function getRegionInfo(control) {
  //top of the control on screen (pixel)
  let top;
  //left of the control on screen (pixel)
  let left
  //height of the control (pixel)
  let height;
  //width of the control (pixel)
  let width;
  let getTop = screen.height().then(y => {
    top = control.top;
  });
  let getLeft = screen.width().then(x => {
    left = control.left;
  });
  let getHeight = screen.height().then(y => {
    height = control.height;
  });
  let getWidth = screen.width().then(x => {
    width = control.width;
  });
  await getTop;
  await getLeft;
  await getHeight;
  await getWidth;
  return {
    top: top,
    left: left,
    height: height,
    width: width
  };
}

async function getMousePosition() {
  let mousePosition;
  let getPosition = mouse.getPosition().then(p => {
    mousePosition = p;
  });
  await getPosition;
  return mousePosition;
}

async function moveMouseToControl(region) {
  let regionInfo = await getRegionInfo(region);
  let mousePosition = await getMousePosition();

  var XDistance = regionInfo.left > mousePosition.x ? (regionInfo.left + regionInfo.width / 2) - mousePosition.x : mousePosition.x - (regionInfo.left + regionInfo.width / 2);
  var YDistance = regionInfo.top > mousePosition.y ? (regionInfo.top + regionInfo.height / 2) - mousePosition.y : mousePosition.y - (regionInfo.top + regionInfo.height / 2);

  if (regionInfo.left > mousePosition.x) {
    await mouse.move(right(Math.abs(XDistance)));
  } else {
    await mouse.move(left(Math.abs(XDistance)));
  }

  if (regionInfo.top < mousePosition.y) {
    await mouse.move(up(Math.abs(YDistance)));
  } else {
    await mouse.move(down(Math.abs(YDistance)));
  }
}

// Export it to make it available outside
module.exports.clickControl = clickControl;